diff --git a/src/compiler/nir/nir_opt_dce.c b/src/compiler/nir/nir_opt_dce.c
index ab2642b29fd..ec47a01658c 100644
--- a/src/compiler/nir/nir_opt_dce.c
+++ b/src/compiler/nir/nir_opt_dce.c
@@ -237,13 +237,7 @@ nir_opt_dce_impl(nir_function_impl *impl)
 
    nir_instr_free_list(&dead_instrs);
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_opt_dead_cf.c b/src/compiler/nir/nir_opt_dead_cf.c
index 592491fec05..b5cf43b7c08 100644
--- a/src/compiler/nir/nir_opt_dead_cf.c
+++ b/src/compiler/nir/nir_opt_dead_cf.c
@@ -388,7 +388,7 @@ opt_dead_cf_impl(nir_function_impl *impl)
    bool progress = dead_cf_list(&impl->body, &dummy);
 
    if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_none);
+      nir_progress(true, impl, nir_metadata_none);
       nir_rematerialize_derefs_in_use_blocks_impl(impl);
 
       /* The CF manipulation code called by this pass is smart enough to keep
@@ -402,7 +402,7 @@ opt_dead_cf_impl(nir_function_impl *impl)
        */
       nir_repair_ssa_impl(impl);
    } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
+      nir_no_progress(impl);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_dead_write_vars.c b/src/compiler/nir/nir_opt_dead_write_vars.c
index d86485c6eb5..0eac227850f 100644
--- a/src/compiler/nir/nir_opt_dead_write_vars.c
+++ b/src/compiler/nir/nir_opt_dead_write_vars.c
@@ -267,13 +267,7 @@ remove_dead_write_vars_impl(void *mem_ctx, nir_shader *shader, nir_function_impl
    nir_foreach_block(block, impl)
       progress |= remove_dead_write_vars_local(mem_ctx, shader, block);
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_opt_find_array_copies.c b/src/compiler/nir/nir_opt_find_array_copies.c
index 42e87c9a557..ec541e2ec39 100644
--- a/src/compiler/nir/nir_opt_find_array_copies.c
+++ b/src/compiler/nir/nir_opt_find_array_copies.c
@@ -651,9 +651,9 @@ opt_find_array_copies_impl(nir_function_impl *impl)
    ralloc_free(s.dead_ctx);
 
    if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    } else {
-      nir_metadata_preserve(impl, nir_metadata_all & ~nir_metadata_instr_index);
+      nir_progress(true, impl, nir_metadata_all & ~nir_metadata_instr_index);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_fragdepth.c b/src/compiler/nir/nir_opt_fragdepth.c
index 4c8e3ff8cce..2c29501d614 100644
--- a/src/compiler/nir/nir_opt_fragdepth.c
+++ b/src/compiler/nir/nir_opt_fragdepth.c
@@ -111,10 +111,8 @@ nir_opt_fragdepth(nir_shader *shader)
        */
       nir_instr_remove(&store_intrin->instr);
 
-      nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                     nir_metadata_loop_analysis |
-                                     nir_metadata_instr_index);
-      progress = true;
+      progress = nir_progress(true, impl,
+                              nir_metadata_control_flow | nir_metadata_loop_analysis | nir_metadata_instr_index);
    }
 
 end:
diff --git a/src/compiler/nir/nir_opt_gcm.c b/src/compiler/nir/nir_opt_gcm.c
index 9d424b2faa2..cb1de480b56 100644
--- a/src/compiler/nir/nir_opt_gcm.c
+++ b/src/compiler/nir/nir_opt_gcm.c
@@ -858,10 +858,10 @@ opt_gcm_impl(nir_shader *shader, nir_function_impl *impl, bool value_number)
    ralloc_free(state.instr_infos);
 
    if (state.progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    } else {
-      nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                     nir_metadata_loop_analysis);
+      nir_progress(true, impl,
+                   nir_metadata_control_flow | nir_metadata_loop_analysis);
    }
 
    return state.progress;
diff --git a/src/compiler/nir/nir_opt_if.c b/src/compiler/nir/nir_opt_if.c
index 0cfb4911341..aeed27bc999 100644
--- a/src/compiler/nir/nir_opt_if.c
+++ b/src/compiler/nir/nir_opt_if.c
@@ -1444,7 +1444,7 @@ nir_opt_if(nir_shader *shader, nir_opt_if_options options)
 
       nir_metadata_require(impl, nir_metadata_control_flow);
       progress = opt_if_safe_cf_list(&b, &impl->body, options);
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
 
       bool preserve = true;
 
@@ -1464,11 +1464,7 @@ nir_opt_if(nir_shader *shader, nir_opt_if_options options)
          nir_lower_reg_intrinsics_to_ssa_impl(impl);
       }
 
-      if (preserve) {
-         nir_metadata_preserve(impl, nir_metadata_none);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      nir_progress(preserve, impl, nir_metadata_none);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_intrinsics.c b/src/compiler/nir/nir_opt_intrinsics.c
index 441e498d287..4e4820fada5 100644
--- a/src/compiler/nir/nir_opt_intrinsics.c
+++ b/src/compiler/nir/nir_opt_intrinsics.c
@@ -428,12 +428,9 @@ nir_opt_intrinsics(nir_shader *shader)
    bool progress = false;
 
    nir_foreach_function_impl(impl, shader) {
-      if (opt_intrinsics_impl(impl, shader->options)) {
-         progress = true;
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      bool impl_progress = opt_intrinsics_impl(impl, shader->options);
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_control_flow);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_large_constants.c b/src/compiler/nir/nir_opt_large_constants.c
index 9ec18888017..fb4346ce506 100644
--- a/src/compiler/nir/nir_opt_large_constants.c
+++ b/src/compiler/nir/nir_opt_large_constants.c
@@ -591,6 +591,5 @@ nir_opt_large_constants(nir_shader *shader,
 
    ralloc_free(var_infos);
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
-   return true;
+   return nir_progress(true, impl, nir_metadata_control_flow);
 }
diff --git a/src/compiler/nir/nir_opt_licm.c b/src/compiler/nir/nir_opt_licm.c
index cf4c729dcdb..41f3e743d80 100644
--- a/src/compiler/nir/nir_opt_licm.c
+++ b/src/compiler/nir/nir_opt_licm.c
@@ -131,13 +131,9 @@ nir_opt_licm(nir_shader *shader)
       nir_metadata_require(impl, nir_metadata_block_index |
                                     nir_metadata_dominance);
 
-      if (visit_cf_list(&impl->body, NULL, NULL)) {
-         progress = true;
-         nir_metadata_preserve(impl, nir_metadata_block_index |
-                                        nir_metadata_dominance);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      bool impl_progress = visit_cf_list(&impl->body, NULL, NULL);
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_block_index | nir_metadata_dominance);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_load_store_vectorize.c b/src/compiler/nir/nir_opt_load_store_vectorize.c
index 3b8d09cb544..b11931a3983 100644
--- a/src/compiler/nir/nir_opt_load_store_vectorize.c
+++ b/src/compiler/nir/nir_opt_load_store_vectorize.c
@@ -1625,9 +1625,8 @@ nir_opt_load_store_vectorize(nir_shader *shader, const nir_load_store_vectorize_
       nir_foreach_block(block, impl)
          progress |= process_block(impl, ctx, block);
 
-      nir_metadata_preserve(impl,
-                            nir_metadata_control_flow |
-                            nir_metadata_live_defs);
+      nir_progress(true, impl,
+                   nir_metadata_control_flow | nir_metadata_live_defs);
    }
 
    ralloc_free(ctx);
diff --git a/src/compiler/nir/nir_opt_loop.c b/src/compiler/nir/nir_opt_loop.c
index 9f8c1a11941..e39457043ca 100644
--- a/src/compiler/nir/nir_opt_loop.c
+++ b/src/compiler/nir/nir_opt_loop.c
@@ -720,13 +720,13 @@ nir_opt_loop(nir_shader *shader)
 
       /* First we run the simple pass to get rid of pesky continues */
       if (opt_loop_cf_list(&b, &impl->body, NULL)) {
-         nir_metadata_preserve(impl, nir_metadata_none);
+         nir_progress(true, impl, nir_metadata_none);
 
          /* If that made progress, we're no longer really in SSA form. */
          nir_lower_reg_intrinsics_to_ssa_impl(impl);
          progress = true;
       } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
+         nir_no_progress(impl);
       }
    }
 
diff --git a/src/compiler/nir/nir_opt_loop_unroll.c b/src/compiler/nir/nir_opt_loop_unroll.c
index 7d56be193d9..e93bce54b45 100644
--- a/src/compiler/nir/nir_opt_loop_unroll.c
+++ b/src/compiler/nir/nir_opt_loop_unroll.c
@@ -1170,10 +1170,10 @@ nir_opt_loop_unroll_impl(nir_function_impl *impl,
                                       &has_nested_loop);
 
    if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_none);
+      nir_progress(true, impl, nir_metadata_none);
       nir_lower_reg_intrinsics_to_ssa_impl(impl);
    } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
+      nir_no_progress(impl);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_memcpy.c b/src/compiler/nir/nir_opt_memcpy.c
index 3234fc794b2..ba388f655c3 100644
--- a/src/compiler/nir/nir_opt_memcpy.c
+++ b/src/compiler/nir/nir_opt_memcpy.c
@@ -274,13 +274,7 @@ opt_memcpy_impl(nir_function_impl *impl)
 
    _mesa_set_destroy(complex_vars, NULL);
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_opt_move.c b/src/compiler/nir/nir_opt_move.c
index 4201edbf6d1..db984518668 100644
--- a/src/compiler/nir/nir_opt_move.c
+++ b/src/compiler/nir/nir_opt_move.c
@@ -145,11 +145,11 @@ nir_opt_move(nir_shader *shader, nir_move_options options)
       }
 
       if (impl_progress) {
-         nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                        nir_metadata_live_defs);
-         progress = true;
+         progress = nir_progress(true, impl,
+                                 nir_metadata_control_flow | nir_metadata_live_defs);
       } else {
-         nir_metadata_preserve(impl, nir_metadata_all & ~nir_metadata_instr_index);
+         nir_progress(true, impl,
+                      nir_metadata_all & ~nir_metadata_instr_index);
       }
    }
 
diff --git a/src/compiler/nir/nir_opt_move_discards_to_top.c b/src/compiler/nir/nir_opt_move_discards_to_top.c
index 5f9f8e7ea5a..a93a40c3c1e 100644
--- a/src/compiler/nir/nir_opt_move_discards_to_top.c
+++ b/src/compiler/nir/nir_opt_move_discards_to_top.c
@@ -360,8 +360,7 @@ nir_opt_move_discards_to_top(nir_shader *shader)
 
    nir_foreach_function_impl(impl, shader) {
       if (opt_move_discards_to_top_impl(impl)) {
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-         progress = true;
+         progress = nir_progress(true, impl, nir_metadata_control_flow);
       }
    }
 
diff --git a/src/compiler/nir/nir_opt_mqsad.c b/src/compiler/nir/nir_opt_mqsad.c
index e38d3c55311..76ef5325ee6 100644
--- a/src/compiler/nir/nir_opt_mqsad.c
+++ b/src/compiler/nir/nir_opt_mqsad.c
@@ -135,10 +135,9 @@ nir_opt_mqsad(nir_shader *shader)
       }
 
       if (progress_impl) {
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-         progress = true;
+         progress = nir_progress(true, impl, nir_metadata_control_flow);
       } else {
-         nir_metadata_preserve(impl, nir_metadata_block_index);
+         nir_progress(true, impl, nir_metadata_block_index);
       }
    }
 
diff --git a/src/compiler/nir/nir_opt_peephole_select.c b/src/compiler/nir/nir_opt_peephole_select.c
index 3735cd29caa..0f2727faa11 100644
--- a/src/compiler/nir/nir_opt_peephole_select.c
+++ b/src/compiler/nir/nir_opt_peephole_select.c
@@ -566,13 +566,7 @@ nir_opt_peephole_select_impl(nir_function_impl *impl,
       progress |= nir_opt_peephole_select_block(block, shader, options);
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_none);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_none);
 }
 
 bool
diff --git a/src/compiler/nir/nir_opt_preamble.c b/src/compiler/nir/nir_opt_preamble.c
index a8134f92b92..a6a3e3c9bd1 100644
--- a/src/compiler/nir/nir_opt_preamble.c
+++ b/src/compiler/nir/nir_opt_preamble.c
@@ -962,8 +962,7 @@ nir_opt_preamble(nir_shader *shader, const nir_opt_preamble_options *options,
       }
    }
 
-   nir_metadata_preserve(impl,
-                         nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 
    ralloc_free(remap_table);
    free(ctx.states);
diff --git a/src/compiler/nir/nir_opt_ray_queries.c b/src/compiler/nir/nir_opt_ray_queries.c
index 8e77a4d2b24..aab10b2acd3 100644
--- a/src/compiler/nir/nir_opt_ray_queries.c
+++ b/src/compiler/nir/nir_opt_ray_queries.c
@@ -233,8 +233,7 @@ nir_opt_ray_query_ranges(nir_shader *shader)
    }
 
    if (ray_query_count <= 1) {
-      nir_metadata_preserve(func->impl, nir_metadata_all);
-      return false;
+      return nir_no_progress(func->impl);
    }
 
    void *mem_ctx = ralloc_context(NULL);
@@ -406,7 +405,7 @@ nir_opt_ray_query_ranges(nir_shader *shader)
       }
    }
 
-   nir_metadata_preserve(func->impl, nir_metadata_all);
+   nir_no_progress(func->impl);
 
    /* Remove dead ray queries. */
    if (progress) {
diff --git a/src/compiler/nir/nir_opt_rematerialize_compares.c b/src/compiler/nir/nir_opt_rematerialize_compares.c
index baf4423dc0f..346795fdc78 100644
--- a/src/compiler/nir/nir_opt_rematerialize_compares.c
+++ b/src/compiler/nir/nir_opt_rematerialize_compares.c
@@ -202,13 +202,7 @@ nir_opt_rematerialize_compares_impl(nir_shader *shader, nir_function_impl *impl)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 static bool
@@ -301,13 +295,7 @@ nir_opt_rematerialize_alu_impl(nir_shader *shader, nir_function_impl *impl)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_opt_shrink_stores.c b/src/compiler/nir/nir_opt_shrink_stores.c
index 027834e1f92..7fbea167b60 100644
--- a/src/compiler/nir/nir_opt_shrink_stores.c
+++ b/src/compiler/nir/nir_opt_shrink_stores.c
@@ -111,12 +111,7 @@ nir_opt_shrink_stores(nir_shader *shader, bool shrink_image_store)
          }
       }
 
-      if (progress) {
-         nir_metadata_preserve(impl,
-                               nir_metadata_control_flow);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      nir_progress(progress, impl, nir_metadata_control_flow);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_shrink_vectors.c b/src/compiler/nir/nir_opt_shrink_vectors.c
index 5311e29f8af..651fe0b81ab 100644
--- a/src/compiler/nir/nir_opt_shrink_vectors.c
+++ b/src/compiler/nir/nir_opt_shrink_vectors.c
@@ -578,12 +578,7 @@ nir_opt_shrink_vectors(nir_shader *shader, bool shrink_start)
          }
       }
 
-      if (progress) {
-         nir_metadata_preserve(impl,
-                               nir_metadata_control_flow);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      nir_progress(progress, impl, nir_metadata_control_flow);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_sink.c b/src/compiler/nir/nir_opt_sink.c
index 046cb9f0cc5..8d5d6d61c78 100644
--- a/src/compiler/nir/nir_opt_sink.c
+++ b/src/compiler/nir/nir_opt_sink.c
@@ -261,8 +261,7 @@ nir_opt_sink(nir_shader *shader, nir_move_options options)
          }
       }
 
-      nir_metadata_preserve(impl,
-                            nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_uniform_atomics.c b/src/compiler/nir/nir_opt_uniform_atomics.c
index e06f5e7d553..eb3425a3a15 100644
--- a/src/compiler/nir/nir_opt_uniform_atomics.c
+++ b/src/compiler/nir/nir_opt_uniform_atomics.c
@@ -333,12 +333,9 @@ nir_opt_uniform_atomics(nir_shader *shader, bool fs_atomics_predicated)
    nir_foreach_function_impl(impl, shader) {
       nir_metadata_require(impl, nir_metadata_block_index | nir_metadata_divergence);
 
-      if (opt_uniform_atomics(impl, fs_atomics_predicated)) {
-         progress = true;
-         nir_metadata_preserve(impl, nir_metadata_none);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      bool impl_progress = opt_uniform_atomics(impl, fs_atomics_predicated);
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_none);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_varyings.c b/src/compiler/nir/nir_opt_varyings.c
index c6ba2d95184..095b9f92541 100644
--- a/src/compiler/nir/nir_opt_varyings.c
+++ b/src/compiler/nir/nir_opt_varyings.c
@@ -5297,14 +5297,10 @@ nir_opt_varyings(nir_shader *producer, nir_shader *consumer, bool spirv,
    /* Part 4: Do compaction. */
    compact_varyings(linkage, &progress);
 
-   nir_metadata_preserve(linkage->producer_builder.impl,
-                         progress & nir_progress_producer ?
-                            (nir_metadata_control_flow) :
-                            nir_metadata_all);
-   nir_metadata_preserve(linkage->consumer_builder.impl,
-                         progress & nir_progress_consumer ?
-                            (nir_metadata_control_flow) :
-                            nir_metadata_all);
+   nir_progress(true, linkage->producer_builder.impl,
+                progress & nir_progress_producer ? (nir_metadata_control_flow) : nir_metadata_all);
+   nir_progress(true, linkage->consumer_builder.impl,
+                progress & nir_progress_consumer ? (nir_metadata_control_flow) : nir_metadata_all);
    free_linkage(linkage);
    FREE(linkage);
 
diff --git a/src/compiler/nir/nir_opt_vectorize.c b/src/compiler/nir/nir_opt_vectorize.c
index e40858b8f07..39789a7c0f2 100644
--- a/src/compiler/nir/nir_opt_vectorize.c
+++ b/src/compiler/nir/nir_opt_vectorize.c
@@ -596,11 +596,7 @@ nir_opt_vectorize_impl(nir_function_impl *impl,
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
+   nir_progress(progress, impl, nir_metadata_control_flow);
 
    vec_instr_set_destroy(instr_set);
    return progress;
diff --git a/src/compiler/nir/nir_opt_vectorize_io.c b/src/compiler/nir/nir_opt_vectorize_io.c
index 04cd236f840..22352199912 100644
--- a/src/compiler/nir/nir_opt_vectorize_io.c
+++ b/src/compiler/nir/nir_opt_vectorize_io.c
@@ -575,9 +575,8 @@ nir_opt_vectorize_io(nir_shader *shader, nir_variable_mode modes)
          progress |= vectorize_batch(&io_instructions);
       }
 
-      nir_metadata_preserve(impl, progress ? (nir_metadata_block_index |
-                                              nir_metadata_dominance) :
-                                             nir_metadata_all);
+      nir_progress(progress, impl,
+                   nir_metadata_block_index | nir_metadata_dominance);
       global_progress |= progress;
    }
    util_dynarray_fini(&io_instructions);
diff --git a/src/compiler/nir/nir_propagate_invariant.c b/src/compiler/nir/nir_propagate_invariant.c
index abf9e5fb664..8bc479424b8 100644
--- a/src/compiler/nir/nir_propagate_invariant.c
+++ b/src/compiler/nir/nir_propagate_invariant.c
@@ -171,14 +171,8 @@ propagate_invariant_impl(nir_function_impl *impl, struct set *invariants)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                     nir_metadata_live_defs);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl,
+                       nir_metadata_control_flow | nir_metadata_live_defs);
 }
 
 /* If invariant_prim=true, this pass considers all geometry-affecting
diff --git a/src/compiler/nir/nir_repair_ssa.c b/src/compiler/nir/nir_repair_ssa.c
index 2cb68f8a9b1..811fb69b61b 100644
--- a/src/compiler/nir/nir_repair_ssa.c
+++ b/src/compiler/nir/nir_repair_ssa.c
@@ -160,7 +160,7 @@ nir_repair_ssa_impl(nir_function_impl *impl)
    }
 
    if (state.progress)
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
 
    if (state.phi_builder) {
       nir_phi_builder_finish(state.phi_builder);
diff --git a/src/compiler/nir/nir_search.c b/src/compiler/nir/nir_search.c
index 619d75b7376..e0157923092 100644
--- a/src/compiler/nir/nir_search.c
+++ b/src/compiler/nir/nir_search.c
@@ -899,8 +899,7 @@ nir_algebraic_impl(nir_function_impl *impl,
     */
    struct util_dynarray states = { 0 };
    if (!util_dynarray_resize(&states, uint16_t, impl->ssa_alloc)) {
-      nir_metadata_preserve(impl, nir_metadata_all);
-      return false;
+      return nir_no_progress(impl);
    }
    memset(states.data, 0, states.size);
 
@@ -950,11 +949,5 @@ nir_algebraic_impl(nir_function_impl *impl,
    ralloc_free(range_ht);
    util_dynarray_fini(&states);
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
diff --git a/src/compiler/nir/nir_split_vars.c b/src/compiler/nir/nir_split_vars.c
index b84656db914..276441c857b 100644
--- a/src/compiler/nir/nir_split_vars.c
+++ b/src/compiler/nir/nir_split_vars.c
@@ -380,10 +380,9 @@ nir_split_struct_vars(nir_shader *shader, nir_variable_mode modes)
          split_struct_derefs_impl(impl, var_field_map,
                                   modes, mem_ctx);
 
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-         progress = true;
+         progress = nir_progress(true, impl, nir_metadata_control_flow);
       } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
+         nir_no_progress(impl);
       }
    }
 
@@ -971,10 +970,9 @@ nir_split_array_vars(nir_shader *shader, nir_variable_mode modes)
          split_array_copies_impl(impl, var_info_map, modes, mem_ctx);
          split_array_access_impl(impl, var_info_map, modes, mem_ctx);
 
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-         progress = true;
+         progress = nir_progress(true, impl, nir_metadata_control_flow);
       } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
+         nir_no_progress(impl);
       }
    }
 
@@ -1730,10 +1728,9 @@ nir_shrink_vec_array_vars(nir_shader *shader, nir_variable_mode modes)
       if (globals_shrunk || locals_shrunk) {
          shrink_vec_var_access_impl(impl, var_usage_map, modes);
 
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-         progress = true;
+         progress = nir_progress(true, impl, nir_metadata_control_flow);
       } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
+         nir_no_progress(impl);
       }
    }
 
diff --git a/src/compiler/nir/nir_sweep.c b/src/compiler/nir/nir_sweep.c
index 6b5da2d1c65..55995f10ad0 100644
--- a/src/compiler/nir/nir_sweep.c
+++ b/src/compiler/nir/nir_sweep.c
@@ -125,7 +125,7 @@ sweep_impl(nir_shader *nir, nir_function_impl *impl)
    sweep_block(nir, impl->end_block);
 
    /* Wipe out all the metadata, if any. */
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 }
 
 static void
diff --git a/src/compiler/nir/nir_to_lcssa.c b/src/compiler/nir/nir_to_lcssa.c
index 6b303c9c485..919febcce86 100644
--- a/src/compiler/nir/nir_to_lcssa.c
+++ b/src/compiler/nir/nir_to_lcssa.c
@@ -406,12 +406,9 @@ nir_convert_to_lcssa(nir_shader *shader, bool skip_invariants, bool skip_bool_in
       foreach_list_typed(nir_cf_node, node, node, &impl->body)
          convert_to_lcssa(node, state);
 
-      if (state->progress) {
-         progress = true;
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      bool impl_progress = state->progress;
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_control_flow);
    }
 
    ralloc_free(state);
diff --git a/src/compiler/nir/nir_trivialize_registers.c b/src/compiler/nir/nir_trivialize_registers.c
index dd0e59a42a8..27c93da1f75 100644
--- a/src/compiler/nir/nir_trivialize_registers.c
+++ b/src/compiler/nir/nir_trivialize_registers.c
@@ -507,7 +507,7 @@ nir_trivialize_registers(nir_shader *s)
          trivialize_stores(impl, block);
       }
 
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    }
 
    return true;
diff --git a/src/compiler/nir/nir_use_dominance.c b/src/compiler/nir/nir_use_dominance.c
index d0645772c46..540846f903e 100644
--- a/src/compiler/nir/nir_use_dominance.c
+++ b/src/compiler/nir/nir_use_dominance.c
@@ -288,7 +288,7 @@ nir_calc_use_dominance_impl(nir_function_impl *impl, bool post_dominance)
       }
    }
 
-   nir_metadata_preserve(impl, nir_metadata_all & ~nir_metadata_instr_index);
+   nir_progress(true, impl, nir_metadata_all & ~nir_metadata_instr_index);
 
    return state;
 }
diff --git a/src/freedreno/ir3/ir3_nir_analyze_ubo_ranges.c b/src/freedreno/ir3/ir3_nir_analyze_ubo_ranges.c
index aa9812606b1..bc03e976c3f 100644
--- a/src/freedreno/ir3/ir3_nir_analyze_ubo_ranges.c
+++ b/src/freedreno/ir3/ir3_nir_analyze_ubo_ranges.c
@@ -591,8 +591,7 @@ ir3_nir_lower_const_global_loads(nir_shader *nir, struct ir3_shader_variant *v)
       nir_foreach_function (function, nir) {
          if (function->impl) {
             if (function->is_preamble) {
-               nir_metadata_preserve(
-                  function->impl, nir_metadata_all);
+               nir_no_progress(function->impl);
                continue;
             }
 
@@ -607,8 +606,7 @@ ir3_nir_lower_const_global_loads(nir_shader *nir, struct ir3_shader_variant *v)
                }
             }
 
-            nir_metadata_preserve(
-               function->impl, nir_metadata_control_flow);
+            nir_progress(true, function->impl, nir_metadata_control_flow);
          }
       }
    }
@@ -697,7 +695,7 @@ ir3_nir_lower_ubo_loads(nir_shader *nir, struct ir3_shader_variant *v)
       if (function->impl) {
          if (function->is_preamble && push_ubos) {
             has_preamble = true;
-            nir_metadata_preserve(function->impl, nir_metadata_all);
+            nir_no_progress(function->impl);
             continue;
          }
          nir_builder builder = nir_builder_create(function->impl);
@@ -711,8 +709,7 @@ ir3_nir_lower_ubo_loads(nir_shader *nir, struct ir3_shader_variant *v)
             }
          }
 
-         nir_metadata_preserve(
-            function->impl, nir_metadata_control_flow);
+         nir_progress(true, function->impl, nir_metadata_control_flow);
       }
    }
    /* Update the num_ubos field for GL (first_ubo_is_default_ubo).  With
diff --git a/src/freedreno/ir3/ir3_nir_lower_64b.c b/src/freedreno/ir3/ir3_nir_lower_64b.c
index a9171c1d4e0..04dcd58cc80 100644
--- a/src/freedreno/ir3/ir3_nir_lower_64b.c
+++ b/src/freedreno/ir3/ir3_nir_lower_64b.c
@@ -383,9 +383,7 @@ ir3_nir_lower_64b_regs(nir_shader *shader)
       }
 
       if (impl_progress) {
-         nir_metadata_preserve(
-            impl, nir_metadata_control_flow);
-         progress = true;
+         progress = nir_progress(true, impl, nir_metadata_control_flow);
       }
    }
 
diff --git a/src/freedreno/ir3/ir3_nir_lower_io_offsets.c b/src/freedreno/ir3/ir3_nir_lower_io_offsets.c
index 72a9337f059..a93e8ec678c 100644
--- a/src/freedreno/ir3/ir3_nir_lower_io_offsets.c
+++ b/src/freedreno/ir3/ir3_nir_lower_io_offsets.c
@@ -326,12 +326,7 @@ lower_io_offsets_func(nir_function_impl *impl)
       progress |= lower_io_offsets_block(block, &b, mem_ctx);
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl,
-                            nir_metadata_control_flow);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/freedreno/ir3/ir3_nir_lower_push_consts_to_preamble.c b/src/freedreno/ir3/ir3_nir_lower_push_consts_to_preamble.c
index e1fdc7dae86..008949ac166 100644
--- a/src/freedreno/ir3/ir3_nir_lower_push_consts_to_preamble.c
+++ b/src/freedreno/ir3/ir3_nir_lower_push_consts_to_preamble.c
@@ -26,7 +26,7 @@ ir3_nir_lower_push_consts_to_preamble(nir_shader *nir,
       .range = v->shader_options.push_consts_dwords);
 
    nir_foreach_function_impl(impl, nir) {
-      nir_metadata_preserve(impl, nir_metadata_none);
+      nir_progress(true, impl, nir_metadata_none);
    }
    return true;
 }
